.Dd Oct 09, 2010
.Dt SHYTE 5
.Sh NAME
.Nm SHYTE
.Nd Simple Plain Text Hypertext System.
.Sh DESCRIPTION
SHYTE is _S_imple _HY_per_TE_xt.  SHYTE documents are pre-formatted plain
text documents, prefixed with SHYTE meta-data.  Links are indicated with
embedded SHYTE Locators.  All is explained in detail below.
.Bl -bullet
.It
All SHYTE documents MUST use the UTF-8 character encoding.
.It
All the lines of SHYTE documents MUST be terminated with newlines (ascii
linefeed).
.It
All the lines of SHYTE documents MUST be wrapped at 79 printable
characters, with the exception of Locator Lines.  The terminating newline
may be the 80th character of a line.
.It
All paragraphs MUST be separated by single blank lines.
.It
All contiguous sentences MUST be separated by two space characters.
.It
SHYTE documents MUST begin with the words, "SHYTE DOCUMENT", in uppercase,
with no other text following, on the first line of the document.  This line
is called the SHYTE Identifier.
.It
SHYTE documents MUST follow the SHYTE Identifier with a meta-data header
resembling an email header.  In normal use, SHYTE browsers MUST hide the
SHYTE Identifier and the meta-data, and MUST provide a means for the user
to examine the complete, unaltered SHYTE Identifier and meta-data, on
demand.  The meta-data MUST be separated from the body of the document by a
blank line.
.Bl -bullet
.It
Meta-data is expressed as key/value pairs.  The base set of header keywords
is:  "Title", "Author", "Copyright", "License", "Version", "Description",
"Date", and, "Tags".
.It
The "Title" keyword MUST appear in all SHYTE document headers.  The rest of
the keywords are optional.
.It
Each keyword MUST occur only once in any header, with the exception of the
"Author" keyword, which may occur multiple times in a header.
.It
The composer of a SHYTE document may supplement this group of keywords with
those of his or her own creation.
.It
Keywords MUST NOT contain whitespace, and be separated from their
corresponding values by a colon followed by an arbitrary amount of
whitespace.  The values may contain whitespace, but the initial whitespace
after the colon MUST NOT be considered part of the value.
.It
Continuation lines of wrapped meta-data must begin with whitespace.  The
leading whitespace of continuation lines MUST not be considered part of the
value.
.It
Creators of SHYTE documents are are encouraged to use the "Description",
and "Tags" keywords to provide meta-data for search engines and indexing
sites to use.  Meta-data can make search more efficient and produce higher
quality search results.
.El
.It
A link from one SHYTE document to another is expressed as a SHYTE Locator,
embedded in document text.  Locators resemble the following
pseudo-regular-expression:  
.Bd -literal -offset left
<-?((HOSTNAME|IP ADDRESS)(:PORT)?)?/path/to/document>
.Ed
.Pp
Some examples of SHYTE Locators:
.Bd -literal -offset left
<mammothcheese.ca/document>
<mammothcheese.ca:2000/foobar/tooley/dumbledare>
</root>
<-mammothcheese.ca/binary/resource>
.Ed
.Bl -bullet
.It
If a locator does not specify the port number on which the server is
listening, the port number used will be 1966, the default Squeers(8) port.
.It
A Locator without a hostname or an IP address is considered to be a
Relative Locator.  The implied host is the origin server of the document in
which the Locator appears.
.It
There is no implied root document on a SHYTE site.  Locators must name the
resource to be requested.  The root document of a SHYTE site MUST be
called, "root".  The root document may also be available under other names,
via hard or symbolic links.
.It
It is not possible to view directories on SHYTE servers.  It is an error of
construction for the path portion of a SHYTE locator to end in a virgule.
.It
SHYTE Locators MUST NOT be spread across multiple lines, no matter what
their length.  If a line of a document is made longer than 79 printable
characters by an embedded SHYTE Locator, then that Locator MUST be moved to
separate line by itself.  These lines with lone long locators are called
Locator Lines.  They are the only lines permitted to be wider than 79
printable characters.
.It
A Locator specifies a SHYTE document, unless a hyphen follows the opening
angle bracket, in which case, the Locator is a Binary Locator.  If a Binary
Locator is selected by the user, a browser MUST be able to download the
resource specified by the path portion to a file in the current directory
with the same basename.  Browsers MAY run applications associated with
certain file types, but this behavior is optional.
.El
.It
Composers of SHYTE documents are encouraged to create long documents.
SHYTE browsers must provide facilities for users to place bookmarks on the
current document, and to search the current document using regular
expressions.
.It
SHYTE browsers MUST cache all the documents visited in a session.  When a
user re-visits an already-visited document, the browser MUST reload the
cached version of that document.  Browsers MUST also provide a means for
the user to re-load documents from their sources, on demand.  The cache
MUST be a session-cache only, and be discarded when the browser exits.
.It
Browsers are not allowed to modify SHYTE documents.  Browsers therefore
must provide the means for the user to scroll the display window
horizontally if the current document is wider than the display window.
.It
An example SHYTE document:
.Bd -literal -offset left
SHYTE DOCUMENT
Title:        Pure SHYTE:  The SHYTE Homepage
Author:       James Gordon Bailie
Copyright:    Copyright (c) James Gordon Bailie, 2010
License:      This file may be freely distributed for non-commercial
              purposes, as long as it is not altered in any way.
              Conversions of the content to other formats are permitted
              as long as none of the text is omitted or modified.
Description:  The homepage of the SHYTE plain text hypertext system.
Tags:         SHYTE, hypertext

THE SHYTE HOMEPAGE

Welcome to SHYTE-Space!  SHYTE is _S_imple _HY_per_TE_xt.  SHYTE documents
are plain text documents with meta-data headers, and links.

Read the SHYTE manual on the web for more details: </shyte>
.Ed
.El
.Sh AUTHORS
.An James Bailie Aq jimmy@mammothcheese.ca
.br
http://www.mammothcheese.ca
