.Dd Oct 09, 2010
.Dt Wackford 1
.Sh NAME
.Nm Wackford
.Nd SHYTE Browser
.Sh SYNOPSIS
.Nm wackford Ao filename Ac ...
.Sh DESCRIPTION
Wackford is the SHYTE client browser for 8-bit documents.  SHYTE is Simple
HYperTExt.  See the shyte(5) manual for details on document structure.
SHYTE documents are served over the network by the Squeers(8) file server.
.Pp
Wackford behaves similarly to vi(1) when that program is invoked as "view".
The following additional behaviors turn Wackford into a SHYTE browser:  
.Bl -bullet
.It
Any filename specified on the command-line or to the :e command, which is
delimited with angle-brackets, is interpreted as a SHYTE Locator.
.It
The < and > keys find the SHYTE Locator occurring before the cursor
position, and after the cursor position, respectively.
.It
The [enter] key loads the SHYTE document specified by the Locator which
begins at the cursor position, unless the Locator is a Binary Locator, in
which case it attempts to download the resource specified by the path
portion of the Locator to the current directory.
.It
The [space] key causes wackford to abandon the current document and reload
the document that was loaded previously.
.It
Control-T causes Wackford to display current document's meta-data.  If
the meta-data is already being displayed, it causes Wackford to display the
current document again.
.It
Control-K
adds the current document to the user's bookmarks file.
.It
Control-V
Loads the user's bookmarks file into the buffer.
.It
Control-R
Reloads the current document from its source.  Wackford caches all
documents viewed in memory.  Revisiting an already-visited document causes
Wackford to reload the document from its cache.  If you believe a document
may have changed since the last time it was visited, it may be reloaded
from its appropriate source with this command.  The cache is discarded when
wackford exits.
.El
.Pp
Almost all of the vi cursor-motion and buffer-scrolling commands are
implemented, as well as bookmark operations and regular-expression searches.
For convenience in disambiguating them, space and tab characters may be
also be specified in regular expressions with the \\b and \\t escape
sequences, respectively.
.Pp
Eight ex commands are recognized.  Local filename completion may be
requested on the ex command line by pressing the tab key.  There are
separate editable histories for ex commands and for regular-expression
searches, which may be browsed with Ctrl-n and Ctrl-p.
.Bl -tag -width ":e"
.It :e
will attempt to load its argument into the buffer, either a plain text file
or a SHYTE document, from either the local filesystem or from a SHYTE
server.  Local filenames starting with whitespace must have a path
prepended to them, in order for the filename to be understood by the "e"
command.  If the argument is delimited with angle brackets, the browser
will consider it a SHYTE Locator, and attempt to load the document from the
appropriate server.
.It :n
will load the next file specified on the command line.
.It :p
will load the previous file specified on the command line
.It :r
will rewind the argument pointer and reload the first file specified on the
command line.
.It :!
will attempt to pass its argument to /bin/sh for execution.
.It :$
will cause the browser to suspend itself and drop back to the shell.  The
shell's "fg" command will return the user to the browser.
.It :b
causes the browser to launch the editor specified by the EDITOR
environment variable, with the user's bookmarks file.
.It :q
will cause the browser to exit.
.El
.Pp
Unlike vi, newlines are displayed as spaces at the ends of lines on screen.
Lines longer than the terminal width are truncated.  Attempting to move the
cursor past the right edge of the screen will scroll the buffer
horizontally.  Wackford will resize itself upon receipt of SIGWINCH.
.Sh AUTHORS
.An James Bailie Aq jimmy@mammothcheese.ca
.br
http://www.mammothcheese.ca
